'
' Card Drawing scripts
' These allow you to set a base deck of cards, and then draw from it.  
' Stores the deck information using GetField & SetField methods
'

#commandset Card Drawing
#event OnStartup CardDrawingInitDeck
#register /setdeck CardDrawingSetDeck Sets the deck to use when drawing.  Format like: "/setdeck 2H;2D;2C;2S;3H;3D;3C;3S", with each card seperated by a ";".
#register /shuffle CardDrawingShuffle Shuffles the deck when there's not enough cards to draw
#register /Draw CardDrawingDraw Draws one or more cards from the deck.  Usage "/draw" For one card, "/draw 3" For 3 cards, etc. 

Sub CardDrawingSetDeckChat
	cs = GetChatSession()
	ci = cs.GetLastItem()	
	ci.Action = "Sets the deck to"
	CardDrawingSetDeck ci.Text
		
End Sub

Sub CardDrawingSetDeck( sDeck)
	s = GetCurrentSession()
	s.SetField "BaseDeck", Trim( sDeck)
	s.SetField "CurrentDeck", Trim( sDeck)
End Sub


Sub CardDrawingInitDeck
	CardDrawingSetDeck "2H;2D;2C;2S;3H;3D;3C;3S;4H;4D;4C;4S;5H;5D;5C;5S;6H;6D;6C;6S;7H;7D;7C;7S;8H;8D;8C;8S;9H;9D;9C;9S;10H;10D;10C;10S;JH;JD;JC;JS;QH;QD;QC;QS;KH;KD;KC;KS;AH;AD;AC;AS"
End Sub

Sub CardDrawingDraw
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()

	nReps = 1
	If Len( Trim( ci.Text)) > 0 Then
		nReps = CInt( ci.Text) + 0
	End If
	
	If nReps < 1 Then nReps = 1

	'get the max number of reps, so you cant draw more than one deck at a time
	deck = s.GetField( "BaseDeck")
	a = split( deck, ";")
	n = UBound( a)
	If nReps > n Then nReps = n
	'

	Randomize

	deck = s.GetField( "CurrentDeck")
	If Len(deck) > 0 Then
		ci.Action = "Draws"
		ci.Text = ""

		'check to see if the deck needs shuffled
		a = split( deck, ";")
		n = UBound( a)
		If n < nReps Then
			addlog "Shuffling deck" 
			s.SetField "CurrentDeck", s.GetField("BaseDeck")
		End If


		Dim i
		For i = 1 to nReps 
			deck = s.GetField( "CurrentDeck")
			a = split( deck, ";")

			n = UBound( a)
			If n > 0 Then
				p = Int((n - 0 + 1) * Rnd + 0)
				pick = a(p)
				ci.Text = ci.Text & "<b>" & pick & "</b> &nbsp;"
				
				deck = ""
				For j = 0 to n
					If j <> p Then
						deck = deck & a(j) & ";"
					End If
				Next
				'get rid of the trailing semicolon cuz it will mess up the next Split()
				If Right( deck, 1) = ";" Then deck = Left( deck, Len( deck) -1)
				
				'deck = replace( deck & ";", pick & ";", "")
				s.SetField "CurrentDeck", deck
			End If
		Next
		
		'ci.Text = ci.Text &  "  left: " & deck
	Else
		ci.Action = "Draws"
		ci.Text = "No deck assigned"		
	End If
End Sub

Sub CardDrawingShuffle
	s = GetCurrentSession()
	cs = GetChatSession()
	ci = cs.GetLastItem()	
	ci.Action = "Shuffles the deck"
	ci.Text = ""
	addlog "Shuffling deck" 
	s.SetField "CurrentDeck", s.GetField("BaseDeck")
End Sub

